
{$APPTYPE GUI}{$MODE DELPHI}

program SDLDemo1;

uses SysUtils,windows,SDL,GOGL_SDL,gl,glu,GraphOGL;

//const

//type

var
  ang:glfloat;
  TypeMemory:integer;
  

procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin	
	
  TextureLoadID('gray11.bmp',0);	
  TextureLoadID('Floor04.bmp',1);
  TextureLoadID('Hred24.bmp',2);  
  
end;
begin

  OpenGL_Texture();

end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin

  OpenGL_I2D(0,0,0,0);               // inizializza la grafica 2D


  OpenGL_Init(1000,0.0,0.0,0.0,0.0);  // reimposta la grafica 3D

end;
procedure OpenGL_Mouse2D();
begin

end;
procedure OpenGL_Keyboard();
begin

end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();  

  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,-5,-30);       // regola l'inquadratura degli elementi nello schermo
  glRotatef(15,1,0,0);           // regola l'inquadratura di n gradi rispetto agli assi x y z     
  
  PutglPointLight(GL_LIGHT0,0,0,5,0,0.1);    

  glRotatef(ang,0,1,0);  
  ang:=ang+2.5;
  
  TextureSelectID(0); 
  Cubo(-5,0,-5, -1,0,-1, 1,2.5,1, 1);
  Cubo(-5,0,5, -1,0,-1, 1,4,1, 1);
  Cubo(5,0,-5, -1,0,-1, 1,5,1, 1); 
  Cubo(5,0,5, -1,0,-1, 1,1,1, 1);  
  
  TextureSelectID(1);
  Cubo(-20,0,-20,20,0.1,20, 3);  
  
  TextureSelectID(2);  
  Sfera(0,2.1,0, 2,32);
  
end;


begin

  if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO
  then fullscreen := false else fullscreen := true;

  if MessageBox(0,'Scegli: SI per usare la meoria di sistema, NO per usare la meoria video', 'Memoria!',MB_YESNO OR MB_ICONQUESTION) = IDNO
  then TypeMemory:=SDL_VIDEO_MEMORY else TypeMemory:=SDL_SYSTEM_MEMORY;  
  
  SDLWindowSetting(true,'');
  SDLCreateOGLWindow('GraphOGL SDL - Esempio di gestione OpenGL con SDL', 800, 600, 32, TypeMemory, fullscreen);
  OpenGL_Init(1000,0.0,0.0,0.0,0.0);		 // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale)
  SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
  SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
  OpenGL_CreateList();                       // carica le liste degli oggetti 
  
  repeat

  SDL_DELAY(0);

  glCLEAR(GL_COLOR_BUFFER_BIT);

  OpenGL_Draw();
  SDL_GL_SWAPBUFFERS;

  SDLSetEvents;
  
  until false;

end.
